#include <neocca.hh>
#include <neoports.hh>
#include <neosupport.hh>

neo::support::ComponentClassDescription::ComponentClassDescription(std::string className, std::string classAlias)
{
	name = className;
	alias = classAlias;
}

neo::cca::ports::ComponentClassDescription_shared 
neo::support::ComponentClassDescription::create( std::string className, std::string classAlias )
{
	neo::support::ComponentClassDescription *nscc =
	       	new neo::support::ComponentClassDescription(className,classAlias);
	neo::cca::ports::ComponentClassDescription_shared nsccs(nscc);
	return nsccs;
}

neo::support::ComponentClassDescription::~ComponentClassDescription()
{
	name += "_DEAD";
	alias += "_DEAD";
}

::std::string 
neo::support::ComponentClassDescription::getComponentClassName() 
throw ()
{
	return name;
}

::std::string 
neo::support::ComponentClassDescription::getDeploymentClassAlias() 
throw ()
{
	return alias;
}

::std::string 
neo::support::ComponentClassDescription::getCCASpecBinding()
throw ()
{
	return "neo";
}
