
#include "neocca.hh"

std::string neo::cca::Version::name() {
  return "Common Component Architecture STL/Boost binding v 0.2.8";
}

std::string neo::cca::Version::id() {
  return "0.2.8";
}

int neo::cca::Version::Major() { return 0; }

int neo::cca::Version::Minor() { return 2; }

int neo::cca::Version::Patch() { return 8; }



#include <iostream>
//
// This is the dummy implementation  that
// can be compiled to a .so and linked globally
// at runtime so that all the neo vtables are properly
// referenced by neo components loaded privately.
// No meaningful implementation goes on here.
//
using namespace std;
namespace neo_dummy {

#define WHINE 0
class TypeMap : public virtual neo::cca::TypeMap
{
public:
  /** required destructor */
  TypeMap(){
#if WHINE
	  cerr << "neo_dummy::TypeMap CTOR. neo::cca::TypeMap vtable loaded." << endl;
#endif
  }
  virtual ~TypeMap(){}
  
  virtual neo::cca::TypeMap_shared cloneData()
  {
    neo::cca::TypeMap_shared tm;
    return tm;
  }
  
  virtual neo::cca::TypeMap_shared cloneEmpty()
  {
    neo::cca::TypeMap_shared tm;
    return tm;
  }
  
  virtual int32_t      getInt(const ::std::string & key,  int32_t defaultValue) throw (neo::cca::TypeMismatchException )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual int64_t  getLong(const ::std::string & key,  int64_t defaultValue) throw (neo::cca::TypeMismatchException )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual float    getFloat(const ::std::string & key,  float defaultValue) throw (neo::cca::TypeMismatchException )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual double   getDouble(const ::std::string & key,  double defaultValue) throw (neo::cca::TypeMismatchException )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual ::std::complex<float> getFcomplex(const ::std::string & key,  ::std::complex<float> defaultValue) throw (neo::cca::TypeMismatchException ) 
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual ::std::complex<double> getDcomplex(const ::std::string & key,  ::std::complex<double> defaultValue) throw (neo::cca::TypeMismatchException ) 
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual ::std::string  getString(const ::std::string & key,  ::std::string defaultValue) throw (neo::cca::TypeMismatchException )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual bool  getBool(const ::std::string & key,  bool defaultValue) throw (neo::cca::TypeMismatchException )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual ::std::vector< int32_t > getIntArray(const ::std::string & key,  ::std::vector< int32_t >&  defaultValue) throw (neo::cca::TypeMismatchException )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual ::std::vector< int64_t > getLongArray(const ::std::string & key,  ::std::vector< int64_t >&  defaultValue) throw (neo::cca::TypeMismatchException )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual ::std::vector< float >    getFloatArray(const ::std::string & key,  ::std::vector< float >&  defaultValue) throw (neo::cca::TypeMismatchException )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual ::std::vector< double > getDoubleArray(const ::std::string & key,  ::std::vector< double >&  defaultValue) throw (neo::cca::TypeMismatchException )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual ::std::vector< ::std::complex<float> > getFcomplexArray(const ::std::string & key,  ::std::vector< ::std::complex<float> >&  defaultValue) throw (neo::cca::TypeMismatchException )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual ::std::vector< ::std::complex<double> > getDcomplexArray(const ::std::string & key,  ::std::vector< ::std::complex<double> >&  defaultValue) throw (neo::cca::TypeMismatchException )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual ::std::vector< ::std::string > getStringArray(const ::std::string & key,  ::std::vector< ::std::string >&  defaultValue) throw (neo::cca::TypeMismatchException )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual ::std::vector< bool > getBoolArray(const ::std::string & key,  ::std::vector< bool >&  defaultValue) throw (neo::cca::TypeMismatchException )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }


  virtual void putInt(const ::std::string & key,  int value)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
      
  virtual void putLong(const ::std::string & key,  int64_t value)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
      
  virtual void putFloat(const ::std::string & key,  float value)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
      
  virtual void putDouble(const ::std::string & key,  double value)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
      
  virtual void putFcomplex(const ::std::string & key,  ::std::complex<float> value) 
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
      
  virtual void putDcomplex(const ::std::string & key,  ::std::complex<double> value)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
      
  virtual void putString(const ::std::string & key, const ::std::string & value)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
      
  virtual void putBool(const ::std::string & key,  bool value)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual void putIntArray(const ::std::string & key,  int * value ,int length)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual void putIntArray(const ::std::string & key,  ::std::vector< int >&  value)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
      
  virtual void putLongArray(const ::std::string & key,  int64_t * value ,int length)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual void putLongArray(const ::std::string & key,  ::std::vector< int64_t >&  value )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
      
  virtual void putFloatArray(const ::std::string & key,  float * value ,int length)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual void putFloatArray(const ::std::string & key,  ::std::vector< float >&  value )
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
      
  virtual void putDoubleArray(const ::std::string & key,  double * value ,int length)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual void putDoubleArray(const ::std::string & key,  ::std::vector< double >&  value)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
      
  virtual void putFcomplexArray(const ::std::string & key,  ::std::complex<float> * value ,int length)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual void putFcomplexArray(const ::std::string & key,  ::std::vector< ::std::complex<float> >&  value)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
      
  virtual void putDcomplexArray(const ::std::string & key,  ::std::complex<double> * value ,int length)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual void putDcomplexArray(const ::std::string & key,  ::std::vector< ::std::complex<double> >&  value)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
      
  virtual void putStringArray(const ::std::string & key,  ::std::vector< ::std::string >&  value)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
      
  virtual void putBoolArray(const ::std::string & key,  bool * value ,int length)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  virtual void putBoolArray(const ::std::string & key,  ::std::vector< bool >&  value)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }

  virtual void remove (const ::std::string & key)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }

  virtual ::std::vector< ::std::string > getAllKeys( enum neo::cca::Type t)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }
  
  
  virtual bool hasKey(const ::std::string & key)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }

  virtual enum neo::cca::Type typeOf(const ::std::string & key)
  { throw neo::cca::TypeMismatchException(neo::cca::NoType, neo::cca::NoType, "dummy implementation. Why are you calling?"); }

} ; // end interface TypeMap

class ComponentID : public virtual neo::cca::ComponentID
{
public:
  
  ComponentID(){
#if WHINE
	  cerr << "neo_dummy::ComponentID CTOR. neo::cca::ComponentID vtable loaded." << endl;
#endif
  }
  virtual ~ComponentID(){}

  virtual ::std::string getInstanceName() throw (neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::ComponentID used. BAD"); }

  virtual ::std::string getSerialization() throw (neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::ComponentID used. BAD"); }

  virtual bool isSameAs(neo::cca::ComponentID_shared cid)
  { throw neo::cca::Exception("neo_dummy::ComponentID used. BAD"); }

}; // end interface ComponentID

class ConnectionID  
{
public:
  ConnectionID(){
#if WHINE
	  cerr << "neo_dummy::ConnectionID CTOR. neo::cca::ConnectionID vtable loaded." << endl;
#endif
  }
  
  virtual ~ConnectionID(){}

  virtual neo::cca::ComponentID_shared getProvider() throw (neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::ConnectionID used. BAD"); }

  virtual neo::cca::ComponentID_shared getUser() throw (neo::cca::Exception ) 
  { throw neo::cca::Exception("neo_dummy::ConnectionID used. BAD"); }

  virtual ::std::string getProviderPortName() throw (neo::cca::Exception ) 
  { throw neo::cca::Exception("neo_dummy::ConnectionID used. BAD"); }

  virtual ::std::string getUserPortName() throw (neo::cca::Exception ) 
  { throw neo::cca::Exception("neo_dummy::ConnectionID used. BAD"); }

} ; // end interface ConnectionID


class Port : public virtual neo::cca::Port
{
public:
  Port(){
#if WHINE
	  cerr << "neo_dummy::Port CTOR. neo::cca::Port vtable loaded." << endl;
#endif
  }
  /** obligatory virtual destructor */
  virtual ~Port (){}
};


class Component  : public virtual neo::cca::Component
{
public:
  Component(){
#if WHINE
	  cerr << "neo_dummy::Component CTOR. neo::cca::Component vtable loaded." << endl;
#endif
  }
  virtual ~Component(){}

  virtual void setServices(neo::cca::Services *cc) throw(neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::Component used. BAD"); }

};

class Services : public virtual neo::cca::Services
{

public:

  Services(){
#if WHINE
	  cerr << "neo_dummy::Services CTOR. neo::cca::Services vtable loaded." << endl;
#endif
  }
  virtual ~Services(){}
  
  virtual neo::cca::Port * getPort(const ::std::string & name) throw(neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::Services getPort used. BAD"); }

  virtual neo::cca::Port * getPortNonBlocking(const ::std::string & name) throw(neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::Services getPortNonBlocking used. BAD"); }

  virtual void releasePort(const ::std::string & name) throw(neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::Services releasePort used. BAD"); }
  
  virtual void registerUsesPort( const ::std::string & name,  const ::std::string & type) throw(neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::Services registerUsesPort used. BAD"); }

  virtual void registerUsesPort( const ::std::string & name,  const ::std::string & type, neo::cca::TypeMap_shared properties) throw(neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::Services registerUsesPort used. BAD"); }


  virtual void unregisterUsesPort(const ::std::string & name) throw(neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::Services unregisterUsesPort used. BAD"); }

  virtual void addProvidesPort( neo::cca::Port * inPort, const ::std::string & name, const ::std::string & type) throw (neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::Services addProvidesPort used. BAD"); }
   
  virtual void addProvidesPort( neo::cca::Port * inPort, const ::std::string & name, const ::std::string & type, neo::cca::TypeMap_shared properties) throw (neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::Services addProvidesPort used. BAD"); }

  virtual void removeProvidesPort(const ::std::string & name)  throw (neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::Services removeProvidesPort used. BAD"); }
  
  virtual neo::cca::ComponentID_shared getComponentID()
  {
	  neo::cca::ComponentID_shared c;
	  return c;
  }

  virtual neo::cca::TypeMap_shared createTypeMap() throw (neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::Services createTypeMap used. BAD"); }

  virtual neo::cca::TypeMap_shared getPortProperties(const ::std::string & portName)  throw (neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::Services getPortProperties used. BAD"); }

  virtual ::std::string genUniquePortName(const ::std::string & base)
  { throw neo::cca::Exception("neo_dummy::Services genUniquePortName used. BAD"); }

  virtual void registerForRelease(neo::cca::ComponentRelease* cr) throw (neo::cca::Exception )
  { throw neo::cca::Exception("neo_dummy::Services registerForRelease used. BAD"); }


};

// global instances to force the vtables in to the .so.
TypeMap dummy_tm;
ComponentID dummy_cid;
ConnectionID  dummy_connid;
Port dummy_port;
Component dummy_component;
Services dummy_services;


}   
