#include <iostream>
#include <cstdio>
#include <neocca.hh>
#include <neoports.hh>
#include "Go.hh"

#ifndef lint
namespace {
char id[] =
"$Id: Go.cpp,v 1.3 2005/10/10 15:21:43 baallan Exp $";
} 
#endif

using namespace std;

//////////////////////////////////////////

neo::test::Go::Go(){ 
	myCore = 0; 
	cout << "!! Go:  CTOR" << endl;
}

neo::test::Go::~Go(){
	myCore = 0;
	cout << "!! Go:  DTOR" << endl;
}

void
neo::test::Go::setServices( neo::cca::Services *cc) 
throw(neo::cca::Exception)
{
	cout << "!! Go:  SET_SERVICES" << endl;
	if (cc == 0)
	{
		cout << "!! neo::test::Go::setServices(0) called." << endl;
		throw neo::cca::Exception("neo::test::Go::setServices(0) called.");
	}
	if (myCore != 0) {
		cout << "!! neo::test::Go::setServices() called twice." << endl;
		throw neo::cca::Exception("neo::test::Go::setServices() called twice.");
	}

	cout << "!! Tester Go: startup" ;
	string myname = cc->getComponentID()->getInstanceName();
	cout << "of instance" << myname << endl ;
	myCore = cc;

	myCore->registerUsesPort( "call_go", "neo::cca::ports::GoPort" );
	myCore->addProvidesPort(this, "go", "neo::cca::ports::GoPort" );
	cout << "!! Go:  startup done"  << endl;
}

int 
neo::test::Go::go()
{

  string myname = myCore->getComponentID()->getInstanceName();
  cout << "!! " << myname << " port 'go' called." << endl;

  neo::cca::ports::GoPort *gp = 0;
  neo::cca::Port *np = 0;
  try {
    np = myCore->getPort("call_go");
    gp = dynamic_cast< ::neo::cca::ports::GoPort *>(np);
    if (gp != 0) {
      cout << "!! " << myname << "Calling go on call_go port." << endl;
      int res = gp->go();
      cout << "!! " << myname << "Called go. received " << res << endl;
      myCore->releasePort("call_go");
    }
  
  } catch (neo::cca::Exception ex) {
    cout << "!! NOTE: Tester Go (" << myname 
	    << ") is not apparently connected on its call_go port." << endl;
  }
  cout << "!! " << myname << " port 'go' finished." << endl;
  return 0;
}

void 
neo::test::Go::releaseServices(neo::cca::Services *svc)
throw(neo::cca::Exception)
{
	if (svc != myCore) {
		throw neo::cca::Exception( "neo::test::Go::releaseServices svc != myCore");
	}
	if (svc == 0) {
		throw neo::cca::Exception( "neo::test::Go::releaseServices called on unstarted/already dead instance.");
	}

	cout << "Go:  shutdown"  << endl;
	myCore->unregisterUsesPort("call_go");
	myCore->removeProvidesPort("go");
	myCore = 0;
	return;
}

extern "C" {

neo::cca::Component *create_neo_test_Go() {
	neo::cca::Component *comp_ptr;
	neo::test::Go *component;
	component = new neo::test::Go();
	comp_ptr = dynamic_cast<neo::cca::Component *>(component);
	return comp_ptr;
}


}

